=== debian/changelog ===
nheko (0.6.4-2build2) focal; urgency=medium

  * Rebuild against new libcmark0.29.0.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sat, 15 Feb 2020 19:31:06 +0100

nheko (0.6.4-2build1) focal; urgency=medium

  * No change rebuild against new boost1.71 ABI

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Mon, 03 Feb 2020 21:09:38 +0000

nheko (0.6.4-2) unstable; urgency=medium

  * debian/control: bump build-depend on nlohmann-json, to fix build failure

 -- Hubert Chathi <uhoreg@debian.org>  Thu, 01 Aug 2019 16:39:11 -0400

nheko (0.6.4-1) unstable; urgency=medium

  * New upstream release.
  * debian/patches/v3_support: Removed -- no longer needed
  * debian/control, debian/rules: don't use ninja
  * debian/control:
    * remove build-dependency hack for boost
    * depend on newer version of nlohmann-json, which includes cmake support
  * debian/copyright: fix copyright for nheko.appdata.xml

 -- Hubert Chathi <uhoreg@debian.org>  Tue, 30 Jul 2019 15:10:29 -0400
