=== debian/changelog ===
nheko (0.7.1-1~bpo10+1) buster-backports; urgency=medium

  [ Pirate Praveen ]
  * Rebuild for buster-backports (Closes: #962750)
  * Update minimum version of libolm-dev to 3.0

  [ Nilesh Patra ]
  * Ignore examples, append relevant flags
  * Update build depends

 -- Pirate Praveen <praveen@debian.org>  Wed, 10 Jun 2020 14:12:29 +0530

nheko (0.7.1-1) unstable; urgency=medium

  * New upstream release.
  * debian/control:
    * don't use alternative build-depends as the buildds don't support it

 -- Hubert Chathi <uhoreg@debian.org>  Fri, 24 Apr 2020 14:02:57 -0400

nheko (0.7.0-1) unstable; urgency=medium

  * New upstream release.
  * debian/control:
    * use backports friendly version
    * new and updated build-depends
    * bump debhelper compat
    * bump standards version
  * debian/patches/series:
    * remove unneeded patches
    * add a patch to hardcode path to tweeny instead of searching with cmake

 -- Hubert Chathi <uhoreg@debian.org>  Thu, 23 Apr 2020 11:56:44 -0400

nheko (0.6.4-3) unstable; urgency=medium

  * debian/rules:
    * respect dpkg-buildflags
    * use external fmt library in spdlog (Closes: #952613)

 -- Hubert Chathi <uhoreg@debian.org>  Thu, 05 Mar 2020 11:55:30 -0500

nheko (0.6.4-2~bpo10+1) buster-backports; urgency=medium

  * Rebuild for buster-backports.

 -- Pirate Praveen <praveen@debian.org>  Sat, 10 Aug 2019 12:19:56 +0530
