## nheko 0.7.2

=== debian/changelog ===
nheko (0.7.2-3) unstable; urgency=medium

  * debian/control:
    * Use default boost dev packages (Closes: #977185)

 -- Hubert Chathi <uhoreg@debian.org>  Mon, 14 Dec 2020 16:02:58 -0500

nheko (0.7.2-2) unstable; urgency=medium

  * debian/control:
    * Recommend fonts-noto-color-emoji
  * patches/no_compile_qml:
    * Don't compile QML files (Closes: #964015)

 -- Hubert Chathi <uhoreg@debian.org>  Fri, 10 Jul 2020 12:22:09 -0400

nheko (0.7.2-1) unstable; urgency=medium

  [ Helmut Grohne ]

  * Fix FTCBFS: (Closes: #962682)
    + Drop g++ build dependency satisfied in buster.
    + Let dh_auto_configure pass cross flags to cmake.

  [ Nilesh Patra ]

  * Fix building for backports.

  [ Hubert Chathi ]

  * New upstream release.

 -- Hubert Chathi <uhoreg@debian.org>  Tue, 16 Jun 2020 17:44:09 -0400
