=== debian/control ===
--- 
+++ 
@@ -6,28 +6,26 @@
 Build-Depends: cmake (>= 3.15)
  , debhelper-compat (=12)
  , dh-exec
- , g++ (>= 4:7)
- , libboost1.71-dev
- , libboost-atomic1.71-dev
- , libboost-chrono1.71-dev
- , libboost-date-time1.71-dev
- , libboost-iostreams1.71-dev
- , libboost-random1.71-dev
- , libboost-regex1.71-dev
- , libboost-system1.71-dev
- , libboost-thread1.71-dev
+ , libboost-dev (>= 1.70)
+ , libboost-atomic-dev (>= 1.70)
+ , libboost-chrono-dev (>= 1.70)
+ , libboost-date-time-dev (>= 1.70)
+ , libboost-iostreams-dev (>= 1.70)
+ , libboost-random-dev (>= 1.70)
+ , libboost-regex-dev (>= 1.70)
+ , libboost-system-dev (>= 1.70)
+ , libboost-thread-dev (>= 1.70)
  , libcmark-dev (>= 0.29)
  , liblmdb++-dev
  , libolm-dev (>= 3.0~)
  , libqt5svg5-dev
- , libspdlog-dev
+ , libspdlog-dev (>= 1.5.0+ds-4)
  , libsodium-dev
  , libssl-dev
  , libtweeny-dev
  , nlohmann-json3-dev (>= 3.7.0-2~)
  , qtbase5-dev (>= 5.10)
  , qtdeclarative5-dev
- , qt5-default
  , libfmt-dev
  , qtquickcontrols2-5-dev
  , qtmultimedia5-dev
@@ -48,7 +46,7 @@
  , qml-module-qtquick-controls2
  , qml-module-qtquick-layouts
  , qml-module-qtquick-window2
-Recommends: ca-certificates
+Recommends: ca-certificates, fonts-noto-color-emoji
 Description: desktop IM client for the Matrix protocol
  Nheko is a Qt-based chat client for Matrix, an open, federated communications
  protocol.  The motivation behind the project is to provide a native desktop
